

--  ------------  Generated from [../../../Source/CommServer/DM2Db/Sp/QS_BccColumnForEmailResults.sp] ---------- 

-- ----------------------------------------------------------------------
--
--           Copyright (c) 1998  CommVault Systems, Inc.
--                  All rights reserved.
--
--
--        This is unpublished proprietary source code of CommVault
--        Systems, Inc. The copyright notice above does not evidence
--        any actual or intended publication of such source code.
--
-- ----------------------------------------------------------------------*/
-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/DM2Db/Sp/QS_BccColumnForEmailResults.sp,v $ $Id: QS_BccColumnForEmailResults.sp,v 1.1.212.2 2018/12/27 18:39:58 vikashkumar Exp $";
SET QUOTED_IDENTIFIER OFF

IF EXISTS (select * from sysobjects where name='QS_BccColumnForEmailResults')
BEGIN
	print '>>> Drop Stored Procedure: QS_BccColumnForEmailResults <<<'
	drop procedure QS_BccColumnForEmailResults
END
IF EXISTS (select * from GxQscripts where name='QS_BccColumnForEmailResults')
	delete from GxQscripts where name = 'QS_BccColumnForEmailResults'
GO

IF EXISTS (select * from GXDBVersions where aliasname='QS_BccColumnForEmailResults')
	delete from GXDBVersions where aliasname = 'QS_BccColumnForEmailResults'
GO
print '... Creating Procedure: QS_BccColumnForEmailResults'
GO
SET QUOTED_IDENTIFIER OFF
GO
create procedure QS_BccColumnForEmailResults
-- Qscript is Enabled
-- Set Audit Level: NO_AUDIT_TRAIL, AUDIT_TRAIL_LEVEL_LOW, _MEDIUM, _HIGH, _CRITICAL
-- Qscript Usage. Do not use special char in HTML
-- SP Input Params
  @i_operation nvarchar(100)='add'
AS
Set NOCOUNT ON
	DECLARE @localErrorMsg	varchar(512)
	SET		@localErrorMsg	='Error Encountered when running script.'
	DECLARE @NoParameter			varchar(10)
	SET     @NoParameter			=''
	DECLARE @AddOperationConst nvarchar(3)
	DECLARE @DropOperationConst nvarchar(6)
	SET @AddOperationConst = 'add'
	SET @DropOperationConst = 'remove'
	IF (@i_operation = @NoParameter)
	BEGIN
		SET @localErrorMsg = 'Error:  Operation Name cannot be empty'
		GOTO CV_EXIT
	END
	ELSE
	BEGIN
		SET @i_operation = LTRIM(RTRIM(@i_operation))
		IF NOT (@i_operation=@AddOperationConst OR @i_operation=@DropOperationConst)
		BEGIN
			SET @localErrorMsg = 'Error:  Invalid Operation Name. Allowed values: ADD, REMOVE'
			GOTO CV_EXIT
		END
	END
	--if operation type is add, then check if Bcc column exists in email results panel and add it..
	IF(@i_operation = @AddOperationConst)
	BEGIN
		IF NOT EXISTS (SELECT * FROM DMUIColumns WHERE ColumnName = 'Bcc')
		BEGIN
			INSERT INTO DMUIColumns (Id, ColumnName, ResourceKey, PropertyName, Width, Alignment)
			VALUES ('14', 'Bcc', 'AppSpecific_EMail_Bcc_ResourceKey', 'emailBcc', 100, '')
		END
		ELSE
		BEGIN
			--IF it already exists, we want to make make sure it is initially hidden column when grid is loaded.
			IF EXISTS (SELECT * FROM DMUIColumns WHERE Id = 14 AND ResourceKey <> 'AppSpecific_EMail_Bcc_ResourceKey')
			BEGIN
				UPDATE DMUIColumns SET ResourceKey = 'AppSpecific_EMail_Bcc_ResourceKey'
				WHERE Id = 14
			END
		END
		--Bcc for Email Results Grid only for compliance site
		IF NOT EXISTS (SELECT * FROM DMUIPanelColumns WHERE ColumnId = '14' AND PanelTypeId = 3)
		BEGIN
			INSERT INTO DMUIPanelColumns (Id, ColumnId, PanelTypeId, BitVisibility, DisplayOrder)
			SELECT MAX(ID) + 1 AS ID, '14', '3', '2', 16
			FROM DMUIPanelColumns
		END
		SET @localErrorMsg = 'Successfully added Bcc column for Email Results'
	END
	IF(@i_operation = @DropOperationConst)
	BEGIN
		IF EXISTS (SELECT * FROM DMUIPanelColumns WHERE ColumnId = '14' AND PanelTypeId = 3)
		BEGIN
			EXEC('DELETE FROM DMUIPanelColumns  WHERE ColumnId = 14 AND PanelTypeId = 3')
			IF @@error = 0
				SET @localErrorMsg = 'Successfully removed Bcc column for Email Results'
		END
		ELSE
		BEGIN
			SET @localErrorMsg = 'Successfully removed Bcc column for Email Results'
		END
	END
CV_EXIT:
	SELECT @localErrorMsg
GO

IF EXISTS (select * from GxQscripts where name = 'QS_BccColumnForEmailResults')
	delete from GxQscripts where name = 'QS_BccColumnForEmailResults'
GO

IF EXISTS (select * from GXDBVersions where aliasname='QS_BccColumnForEmailResults')
	delete from GXDBVersions where aliasname = 'QS_BccColumnForEmailResults'
GO

insert into GXDBVersions values(2, 'QS_BccColumnForEmailResults',  '00010001021200020000', 'QS_BccColumnForEmailResults', '00010001021200020000')
GO

insert into GxQscripts values(2,'QS_BccColumnForEmailResults',  0, GETDATE(), GETDATE(), '' + CHAR(10) + '-- 	To add/remove Bcc column for email search results panel'
 + CHAR(10) + '-- 	qoperation execscript -dbn DM2 -c ''client Name'' -sn BccColumnForEmailResults -si ''flag'' '
 + CHAR(10) + '-- 	''client Name'' -- client name of the Webserver machine'
 + CHAR(10) + '-- 	''flag'' -- flag can be add or remove and is optional. Default is add.'
)
GO

