

--  ------------  Generated from [../../../Source/CommServer/DM2Db/Sp/QS_SetCustomizeLogoPath.sp] ---------- 

-- ----------------------------------------------------------------------
--
--           Copyright (c) 1998  CommVault Systems, Inc.
--                  All rights reserved.
--
--
--        This is unpublished proprietary source code of CommVault
--        Systems, Inc. The copyright notice above does not evidence
--        any actual or intended publication of such source code.
--
-- ----------------------------------------------------------------------*/
-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/DM2Db/Sp/QS_SetCustomizeLogoPath.sp,v $ $Id: QS_SetCustomizeLogoPath.sp,v 1.1.2.3 2018/12/27 18:28:28 vikashkumar Exp $";
SET QUOTED_IDENTIFIER OFF

IF EXISTS (select * from sysobjects where name='QS_SetCustomizeLogoPath')
BEGIN
	print '>>> Drop Stored Procedure: QS_SetCustomizeLogoPath <<<'
	drop procedure QS_SetCustomizeLogoPath
END
IF EXISTS (select * from GxQscripts where name='QS_SetCustomizeLogoPath')
	delete from GxQscripts where name = 'QS_SetCustomizeLogoPath'
GO

IF EXISTS (select * from GXDBVersions where aliasname='QS_SetCustomizeLogoPath')
	delete from GXDBVersions where aliasname = 'QS_SetCustomizeLogoPath'
GO
print '... Creating Procedure: QS_SetCustomizeLogoPath'
GO
SET QUOTED_IDENTIFIER OFF
GO
create procedure QS_SetCustomizeLogoPath
-- Qscript is Enabled
-- Set Audit Level: NO_AUDIT_TRAIL, AUDIT_TRAIL_LEVEL_LOW, _MEDIUM, _HIGH, _CRITICAL
-- Qscript Usage. Do not use special char in HTML
-- SP Input Params
  @i_PathForSearchSite nvarchar(1024),
  @i_PathForComplianceSite nvarchar(1024)
AS
Set NOCOUNT ON
	DECLARE @localErrorMsg	varchar(512)
	SET		@localErrorMsg	='Completed script execution.'
	DECLARE @NoParameter			varchar(10)
	SET     @NoParameter			=''
	IF @i_PathForSearchSite = @NoParameter AND @i_PathForComplianceSite = @NoParameter
	BEGIN
		SET @localErrorMsg = 'Error:  Atleast one path must be supplied as input for end user or compliance search site logo'
		GOTO CV_EXIT
	END
	ELSE
	BEGIN
		SET @i_PathForSearchSite = LTRIM(RTRIM(@i_PathForSearchSite))
		SET @i_PathForComplianceSite = LTRIM(RTRIM(@i_PathForComplianceSite))
	END
	IF @i_PathForSearchSite <> @NoParameter
	BEGIN
	if exists (select PrefValue from DMAdminPref where PrefName='Custom_Image_File_Path' and ViewName = '63DE0B7A-890A-400D-B3A2-A6630FA362BC') --END USER
		begin
			update DMAdminPref
			set PrefValue = @i_PathForSearchSite
			where PrefName='Custom_Image_File_Path' and ViewName = '63DE0B7A-890A-400D-B3A2-A6630FA362BC'
		end
	else
		begin
			INSERT INTO DMAdminPref (ViewName, PrefName, PrefValue, CreatedTime, CreatedBy, ModifiedTime, ModifiedBy)
			SELECT '63DE0B7A-890A-400D-B3A2-A6630FA362BC' ViewName, 'Custom_Image_File_Path' PrefName, @i_PathForSearchSite PrefValue, GETDATE() CreatedTime, 1 CreatedBy, GETDATE() ModifiedTime,
			1 ModifiedBy
		end
	END
	IF @i_PathForComplianceSite  <> @NoParameter
	BEGIN
		if exists (select PrefValue from DMAdminPref where PrefName='Custom_Image_File_Path' and ViewName = 'E2E3732B-3887-4C49-A23B-EBCCDDD25D9C') --COMPLIANCE SEARCH
			begin
				update DMAdminPref
				set PrefValue = @i_PathForComplianceSite
				where PrefName='Custom_Image_File_Path' and ViewName = 'E2E3732B-3887-4C49-A23B-EBCCDDD25D9C'
			end
		else
			begin
				INSERT INTO DMAdminPref (ViewName, PrefName, PrefValue, CreatedTime, CreatedBy, ModifiedTime, ModifiedBy)
				SELECT 'E2E3732B-3887-4C49-A23B-EBCCDDD25D9C' ViewName, 'Custom_Image_File_Path' PrefName, @i_PathForComplianceSite PrefValue, GETDATE() CreatedTime, 1 CreatedBy, GETDATE()
				ModifiedTime, 1 ModifiedBy
			end
	END
CV_EXIT:
	SELECT @localErrorMsg
GO

IF EXISTS (select * from GxQscripts where name = 'QS_SetCustomizeLogoPath')
	delete from GxQscripts where name = 'QS_SetCustomizeLogoPath'
GO

IF EXISTS (select * from GXDBVersions where aliasname='QS_SetCustomizeLogoPath')
	delete from GXDBVersions where aliasname = 'QS_SetCustomizeLogoPath'
GO

insert into GXDBVersions values(2, 'QS_SetCustomizeLogoPath',  '00010001000200030000', 'QS_SetCustomizeLogoPath', '00010001000200030000')
GO

insert into GxQscripts values(2,'QS_SetCustomizeLogoPath',  0, GETDATE(), GETDATE(), '' + CHAR(10) + '-- 	To insert or update customized logo path in web server database for compliance or end user site.'
 + CHAR(10) + '-- 	qoperation execscript -dbn DM2 -c ''client Name'' -sn SetCustomizeLogoPath -si ''PathToEndUserSiteLogo'' -si ''PathToComplianceSiteLogo'''
 + CHAR(10) + '-- 	''client Name'' -- client name of the Webserver machine'
 + CHAR(10) + '-- 	''PathToEndUserSiteLogo'' -- Path on the web server machine for end user search site logo'
 + CHAR(10) + '-- 	''PathToComplianceSiteLogo'' -- Path on the web server machine for compliance search site logo'
)
GO

