

--  ------------  Generated from [../../../Source/CommServer/DM2Db/Sp/sp_dm2_CreateCLRFunctions.sp] ---------- 

-- dataServer_h_rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/DM2Db/Sp/sp_dm2_CreateCLRFunctions.sp,v $ $Id: sp_dm2_CreateCLRFunctions.sp,v 1.14.12.3 2020/07/16 18:59:05 sgolla Exp $";
--  +===============================================================================+
--  | Stored Proc:  sp_dm2_CreateCLRFunctions()
--  |
--  | Description:  Create CLR functions and stored procedures
--  +===============================================================================+
SET QUOTED_IDENTIFIER OFF

IF EXISTS (select * from sysobjects where name='sp_dm2_CreateCLRFunctions')
BEGIN
	print '>>> Drop Stored Procedure: sp_dm2_CreateCLRFunctions <<<'
	drop procedure sp_dm2_CreateCLRFunctions
END
IF EXISTS (select * from GxQscripts where name='sp_dm2_CreateCLRFunctions')
	delete from GxQscripts where name = 'sp_dm2_CreateCLRFunctions'
GO

IF EXISTS (select * from GXDBVersions where aliasname='sp_dm2_CreateCLRFunctions')
	delete from GXDBVersions where aliasname = 'sp_dm2_CreateCLRFunctions'
GO
print '... Creating Procedure: sp_dm2_CreateCLRFunctions'
GO
SET QUOTED_IDENTIFIER OFF
GO
create procedure sp_dm2_CreateCLRFunctions
  @i_DLLPath NVARCHAR(MAX)
AS
  DECLARE @o_retVal INTEGER;
	--This will turn off message: "xxx rows affected".
	SET NOCOUNT ON
	DECLARE @sqlQuery 			NVARCHAR(MAX)
	DECLARE @DLLPathUtils		NVARCHAR(MAX)
	DECLARE @DLLPathLogger 	NVARCHAR(MAX)
	DECLARE @DLLPathXMLMsg	NVARCHAR(MAX)
	SET @sqlQuery = 'USE MASTER ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'IF EXISTS (SELECT name FROM syslogins WHERE name = ''CVDM2DBCLRLogin'') ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + '  DROP LOGIN CVDM2DBCLRLogin ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'IF EXISTS (SELECT name FROM sys.asymmetric_keys WHERE name = ''CVDM2DBCLRKey'') ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'DROP ASYMMETRIC KEY CVDM2DBCLRKey ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'IF EXISTS (SELECT name FROM syslogins WHERE name = ''CVManagedLoggerLogin'') ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + '  DROP LOGIN CVManagedLoggerLogin ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'IF EXISTS (SELECT name FROM sys.asymmetric_keys WHERE name = ''CVManagedLoggerKey'') ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'DROP ASYMMETRIC KEY CVManagedLoggerKey ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'IF EXISTS (SELECT name FROM syslogins WHERE name = ''CVDM2XMLMsgLogin'') ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + '  DROP LOGIN CVDM2XMLMsgLogin ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'IF EXISTS (SELECT name FROM sys.asymmetric_keys WHERE name = ''CVDM2XMLManagedMsgKey'') ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'DROP ASYMMETRIC KEY CVDM2XMLManagedMsgKey ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'USE MASTER ' + CHAR(10)
	SET @DLLPathUtils = @i_DLLPath + '\CommonUtils.dll'
	SET @DLLPathLogger = @i_DLLPath + '\CVManagedLogger.dll'
	--SET @DLLPathXMLMsg = @i_DLLPath + '\XmlManagedMsg.dll'  --Requires trustworthy on which means additional concerns, dropping its use in CLR functions
	--SET @sqlQuery = @sqlQuery + 'CREATE ASYMMETRIC KEY CVDM2XMLManagedMsgKey FROM EXECUTABLE FILE = ''' + @DLLPathXMLMsg + '''' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'CREATE LOGIN CVDM2XMLMsgLogin FROM ASYMMETRIC KEY CVDM2XMLManagedMsgKey ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'GRANT UNSAFE ASSEMBLY TO CVDM2XMLMsgLogin ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'CREATE ASYMMETRIC KEY CVManagedLoggerKey FROM EXECUTABLE FILE = ''' + @DLLPathLogger + '''' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'CREATE LOGIN CVManagedLoggerLogin FROM ASYMMETRIC KEY CVManagedLoggerKey ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'GRANT UNSAFE ASSEMBLY TO CVManagedLoggerLogin ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'CREATE ASYMMETRIC KEY CVDM2DBCLRKey FROM EXECUTABLE FILE = ''' + @DLLPathUtils + '''' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'CREATE LOGIN CVDM2DBCLRLogin FROM ASYMMETRIC KEY CVDM2DBCLRKey ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'GRANT UNSAFE ASSEMBLY TO CVDM2DBCLRLogin ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'USE MASTER ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'EXEC sp_configure ''show advanced options'', 1 ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'RECONFIGURE ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'USE MASTER ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'EXEC sp_configure ''clr enabled'' , 1 ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'RECONFIGURE ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	--
	-- Starting SP14, we got rid of PERMISSION_SET = UNSAFE which cause security concerns
	-- Since then we do not need xp_cmdshell and Ole Automation Procedures to be changed at all
	-- Duplicate code existed one of which was commented out in SP14 itself but other set remained
	-- This raises continued security concern from customers, so removing that too..
	--
	--SET @sqlQuery = 'USE MASTER ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'EXEC sp_configure ''xp_cmdshell'' , 1 ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'RECONFIGURE ' + CHAR(10)
	--EXECUTE sp_executeSql @sqlQuery
	--SET @o_retVal = @@ERROR
	--IF	@o_retVal <> 0 GOTO CX_EXIT
	--SET @sqlQuery = 'USE MASTER ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'EXEC sp_configure ''Ole Automation Procedures'', 1 ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'RECONFIGURE ' + CHAR(10)
	--EXECUTE sp_executeSql @sqlQuery
	--SET @o_retVal = @@ERROR
	--IF	@o_retVal <> 0 GOTO CX_EXIT
	--SET @sqlQuery = 'USE MASTER ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'EXEC sp_configure ''xp_cmdshell'' , 1 ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'RECONFIGURE ' + CHAR(10)
	--EXECUTE sp_executeSql @sqlQuery
	--SET @o_retVal = @@ERROR
	--IF	@o_retVal <> 0 GOTO CX_EXIT
	--SET @sqlQuery = 'USE MASTER ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'EXEC sp_configure ''Ole Automation Procedures'', 1 ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'RECONFIGURE ' + CHAR(10)
	--EXECUTE sp_executeSql @sqlQuery
	--SET @o_retVal = @@ERROR
	--IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N''[dbo].[ConvertLegalHoldMetaDataXMLTo900XMLManaged]'') AND OBJECTPROPERTY(object_id, N''IsInlineFunction'') = 0) ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + '	DROP FUNCTION [dbo].[ConvertLegalHoldMetaDataXMLTo900XMLManaged] ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N''[dbo].[ConvertResultItemXMLTo900XMLManaged]'') AND OBJECTPROPERTY(object_id, N''IsInlineFunction'') = 0) ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + '	DROP FUNCTION [dbo].[ConvertResultItemXMLTo900XMLManaged] ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N''[dbo].[GetOwnerFieldManaged]'') AND OBJECTPROPERTY(object_id, N''IsInlineFunction'') = 0) ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + '	DROP FUNCTION [dbo].[GetOwnerFieldManaged] ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N''[dbo].[DecodeInvalidXMLCharsManaged]'') AND OBJECTPROPERTY(object_id, N''IsInlineFunction'') = 0) ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + '	DROP FUNCTION [dbo].[DecodeInvalidXMLCharsManaged] ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N''[dbo].[EncodeInvalidXMLCharsManaged]'') AND OBJECTPROPERTY(object_id, N''IsInlineFunction'') = 0) ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + '	DROP FUNCTION [dbo].[EncodeInvalidXMLCharsManaged] ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'IF EXISTS (SELECT name FROM sys.assemblies asms WHERE asms.name = N''CommonUtils'') ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + '	DROP ASSEMBLY [CommonUtils] ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'IF EXISTS (SELECT name FROM sys.assemblies asms WHERE asms.name = N''XmlManagedMsg'') ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + '	DROP ASSEMBLY [XmlManagedMsg] ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'IF EXISTS (SELECT name FROM sys.assemblies asms WHERE asms.name = N''CVManagedLogger'') ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + '	DROP ASSEMBLY [CVManagedLogger] ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'IF EXISTS (SELECT name FROM sys.assemblies asms WHERE asms.name = N''SystemWeb'') ' + CHAR(10)
    SET @sqlQuery = @sqlQuery + '  DROP ASSEMBLY [SystemWeb]' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
    SET @sqlQuery = 'IF EXISTS (SELECT name FROM sys.assemblies asms WHERE asms.name = N''SystemRunTimeSerialization'') ' + CHAR(10)
    SET @sqlQuery = @sqlQuery + '  DROP ASSEMBLY [SystemRunTimeSerialization]' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
    SET @sqlQuery =  'IF EXISTS (SELECT * FROM sys.assemblies asms WHERE asms.name = N''SMdiagnostics'') ' + CHAR(10)
    SET @sqlQuery = @sqlQuery + ' DROP ASSEMBLY [SMdiagnostics] ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	select @sqlQuery = 'Alter database ' + db_name() + ' set trustworthy off' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	--DECLARE @windir nvarchar(255)
	--declare @WindirTmp table
	--(
	--	EnvVar nvarchar(255)
	--)
	--INSERT INTO @WindirTmp exec xp_cmdshell 'echo %windir%'
	--SET @windir = (SELECT TOP 1 EnvVar from @WindirTmp)
	--if (patindex('%\',@windir)=0)
	--begin
	--	SET @windir = @windir + '\'
	--end
	--if exists(select 1 from sys.dm_clr_properties
	--	where name='version'
	--	and value like '%v4%')
	--begin
	--	SET @sqlQuery = 'create assembly [SMdiagnostics] from  N''' + @windir+ 'Microsoft.NET\Framework\v4.0.30319\SMdiagnostics.dll'' WITH PERMISSION_SET = UNSAFE ' + CHAR(10)
	--	EXECUTE sp_executeSql @sqlQuery
	--	SET @o_retVal = @@ERROR
	--	IF	@o_retVal <> 0 GOTO CX_EXIT
	--	SET @sqlQuery = 'CREATE ASSEMBLY [SystemRunTimeSerialization] FROM N''' + @windir+ N'Microsoft.NET\Framework\v4.0.30319\System.Runtime.Serialization.dll'' WITH PERMISSION_SET = UNSAFE ' + CHAR(10)
	--	EXECUTE sp_executeSql @sqlQuery
	--	SET @o_retVal = @@ERROR
	--	IF	@o_retVal <> 0 GOTO CX_EXIT
	--	SET @sqlQuery = 'CREATE ASSEMBLY [SystemWeb] FROM N''' + @windir+ N'Microsoft.NET\Framework64\v4.0.30319\System.Web.dll'' WITH PERMISSION_SET = UNSAFE ' + CHAR(10)
	--	EXECUTE sp_executeSql @sqlQuery
	--	SET @o_retVal = @@ERROR
	--	IF	@o_retVal <> 0 GOTO CX_EXIT
	--end
	--else
	--begin
	--	SET @sqlQuery = 'create assembly [SMdiagnostics] from  N''' + @windir+ 'Microsoft.NET\Framework\v3.0\Windows Communication Foundation\SMdiagnostics.dll'' WITH PERMISSION_SET = UNSAFE ' + CHAR(10)
	--	EXECUTE sp_executeSql @sqlQuery
	--	SET @o_retVal = @@ERROR
	--	IF	@o_retVal <> 0 GOTO CX_EXIT
	--	SET @sqlQuery = 'CREATE ASSEMBLY [SystemRunTimeSerialization] FROM N''' + @windir+ N'Microsoft.NET\Framework\v3.0\Windows Communication Foundation\System.Runtime.Serialization.dll'' WITH PERMISSION_SET = UNSAFE ' + CHAR(10)
	--	EXECUTE sp_executeSql @sqlQuery
	--	SET @o_retVal = @@ERROR
	--	IF	@o_retVal <> 0 GOTO CX_EXIT
	--	SET @sqlQuery = 'CREATE ASSEMBLY [SystemWeb] FROM N''' + @windir+ N'Microsoft.NET\Framework64\v2.0.50727\System.Web.dll'' WITH PERMISSION_SET = UNSAFE ' + CHAR(10)
	--	EXECUTE sp_executeSql @sqlQuery
	--	SET @o_retVal = @@ERROR
	--	IF	@o_retVal <> 0 GOTO CX_EXIT
	--end
	SET @sqlQuery = 'CREATE ASSEMBLY CVManagedLogger FROM N''' + @DLLPathLogger + ''' WITH PERMISSION_SET = UNSAFE ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	--SET @sqlQuery = 'CREATE ASSEMBLY XmlManagedMsg FROM N''' + @DLLPathXMLMsg + ''' WITH PERMISSION_SET = UNSAFE ' + CHAR(10)
	--EXECUTE sp_executeSql @sqlQuery
	--SET @o_retVal = @@ERROR
	--IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'CREATE ASSEMBLY CommonUtils FROM N''' + @DLLPathUtils + ''' WITH PERMISSION_SET = UNSAFE ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	--SET @sqlQuery = 'CREATE FUNCTION [dbo].[ConvertLegalHoldMetaDataXMLTo900XMLManaged] ( @oldLHMetaDataXML NVARCHAR(MAX) ) ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'RETURNS NVARCHAR(MAX) ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'WITH EXECUTE AS CALLER ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'AS ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'EXTERNAL NAME [CommonUtils].[Commvault.Utils.UserDefinedFunctions].[ConvertLegalHoldMetaDataXMLTo900XML] ' + CHAR(10)
	--EXECUTE sp_executeSql @sqlQuery
	--SET @o_retVal = @@ERROR
	--IF	@o_retVal <> 0 GOTO CX_EXIT
	--SET @sqlQuery = 'CREATE FUNCTION [dbo].[ConvertResultItemXMLTo900XMLManaged] ( @ResultItemID NVARCHAR(36), @oldResultItemXML NVARCHAR(MAX) ) ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'RETURNS NVARCHAR(MAX) ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'WITH EXECUTE AS CALLER ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'AS ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'EXTERNAL NAME [CommonUtils].[Commvault.Utils.UserDefinedFunctions].[ConvertResultItemXMLTo900XML] ' + CHAR(10)
	--EXECUTE sp_executeSql @sqlQuery
	--SET @o_retVal = @@ERROR
	--IF	@o_retVal <> 0 GOTO CX_EXIT
	--SET @sqlQuery = 'CREATE FUNCTION [dbo].[GetOwnerFieldManaged] (@fromField NVARCHAR(MAX), @lnks NVARCHAR(MAX), @filePath NVARCHAR(MAX), @getMailOwnerStr NVARCHAR(10) ) ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'RETURNS NVARCHAR(MAX) ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'WITH EXECUTE AS CALLER ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'AS ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'EXTERNAL NAME [CommonUtils].[Commvault.Utils.UserDefinedFunctions].[GetOwnerField] ' + CHAR(10)
	--EXECUTE sp_executeSql @sqlQuery
	--SET @o_retVal = @@ERROR
	--IF	@o_retVal <> 0 GOTO CX_EXIT
	SET @sqlQuery = 'CREATE FUNCTION [dbo].[DecodeInvalidXMLCharsManaged] (@inputString NVARCHAR(MAX)) ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'RETURNS NVARCHAR(MAX) ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'WITH EXECUTE AS CALLER ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'AS ' + CHAR(10)
	SET @sqlQuery = @sqlQuery + 'EXTERNAL NAME [CommonUtils].[Commvault.Utils.UserDefinedFunctions].[DecodeInvalidXMLCharsHelper] ' + CHAR(10)
	EXECUTE sp_executeSql @sqlQuery
	SET @o_retVal = @@ERROR
	IF	@o_retVal <> 0 GOTO CX_EXIT
	--SET @sqlQuery = 'CREATE FUNCTION [dbo].[EncodeInvalidXMLCharsManaged] (@inputString NVARCHAR(MAX) ) ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'RETURNS NVARCHAR(MAX) ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'WITH EXECUTE AS CALLER ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'AS ' + CHAR(10)
	--SET @sqlQuery = @sqlQuery + 'EXTERNAL NAME [CommonUtils].[Commvault.Utils.UserDefinedFunctions].[EncodeInvalidXMLCharsHelper] ' + CHAR(10)
	--EXECUTE sp_executeSql @sqlQuery
	--SET @o_retVal = @@ERROR
	--IF	@o_retVal <> 0 GOTO CX_EXIT
CX_EXIT:
	SELECT @o_retVal
	RETURN @o_retVal
GO

IF EXISTS (select * from GxQscripts where name = 'sp_dm2_CreateCLRFunctions')
	delete from GxQscripts where name = 'sp_dm2_CreateCLRFunctions'
GO

IF EXISTS (select * from GXDBVersions where aliasname='sp_dm2_CreateCLRFunctions')
	delete from GXDBVersions where aliasname = 'sp_dm2_CreateCLRFunctions'
GO

insert into GXDBVersions values(2, 'sp_dm2_CreateCLRFunctions',  '00010014001200030000', 'sp_dm2_CreateCLRFunctions', '00010014001200030000')
GO

