

--  ------------  Generated from [../../../Source/CommServer/DM2Db/Upgrade/DMItemsToSyncWithIndexing.upg] ---------- 

--USE commserv
SET QUOTED_IDENTIFIER OFF
--$Id: DMItemsToSyncWithIndexing.upg,v 1.3.60.1 2017/02/10 19:16:57 chandru Exp $
BEGIN--Need a Batch to return out of for concatenated scripts
DECLARE @oldRev CHAR(20)    		
  	DECLARE @oldVal CHAR(256)			
  	DECLARE @retCode   INTEGER			
  	DECLARE @sqlError  INTEGER			
  	SET     @retCode = 0              	
  	DECLARE @sqlString nvarchar(MAX)	
      DECLARE @parentID INTEGER				
      DECLARE @tName nvarchar(128)			
      DECLARE @colID INTEGER					
      DECLARE @constId INTEGER				
      DECLARE @cName   nvarchar(128)			
  	DECLARE @oldConstraintName   nvarchar(128)	
  	DECLARE @newConstraintName   nvarchar(128)	
  	DECLARE @keyname   nvarchar(128)		
      DECLARE @dbName   nvarchar(128)			
  	DECLARE @IsNullableAttr VARCHAR(100)	
  	DECLARE @DefaultValAttr NVARCHAR(MAX)	
  	DECLARE @DataType     NVARCHAR(	256)	
  	SET ROWCOUNT 0							
  	SET NOCOUNT ON--Declare/Initialize @oldRev, @oldVal, @retCode
SELECT @dbName = DB_NAME()													
  SELECT @oldRev = (SELECT revision FROM GXDBVersions WHERE name = 'DMItemsToSyncWithIndexing')	
  IF (@oldRev IS NULL)														
  BEGIN                 														
      SET @oldRev = '0.0'														
  END																			
  IF NOT EXISTS (SELECT * FROM sysobjects										
  WHERE type = 'U'															
  AND name = 'DMItemsToSyncWithIndexing')														
  BEGIN																		
  	SET @oldRev = '0.0'														
  	DELETE FROM GXDBVersions WHERE name = 'DMItemsToSyncWithIndexing'							
  END																			
  IF (@oldRev = '1.2')       												
  BEGIN																		
      PRINT 'RETVAL: 0   Table [' +'DMItemsToSyncWithIndexing' +'] does NOT require upgrade.'	
  END																			
  else																		
  BEGIN																		
      PRINT 'Upgrading Table [' +'DMItemsToSyncWithIndexing' +'].'							
  END--	 Get @oldRev, compare to '1.2'. Chk for work to do.


IF NOT EXISTS (select * from sysobjects where id = object_id(N'[dbo].[DMItemsToSyncWithIndexing]') and OBJECTPROPERTY(id, N'IsTable') = 1)
BEGIN



--  ------------  Generated from [../../../Source/CommServer/DM2Db/Tbl/DMItemsToSyncWithIndexing.tbl] ---------- 





-- ALLOW_COMMENTS_BELOW_HERE:

-- ----------------------------------------------------------------------

--

--           Copyright (c) 1998  CommVault Systems, Inc.

--                  All rights reserved.

--

--

--        This is unpublished proprietary source code of CommVault

--        Systems, Inc. The copyright notice above does not evidence

--        any actual or intended publication of such source code.

-- ----------------------------------------------------------------------*/

-- rcsid="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/DM2Db/Tbl/DMItemsToSyncWithIndexing.tbl,v $ $Id: DMItemsToSyncWithIndexing.tbl,v 1.2 2012/10/10 18:29:41 hkapadia Exp $";

print '... Creating Table: DMItemsToSyncWithIndexing'

exec ('



DECLARE @tblRetCode integer

Set NOCOUNT ON





create table DMItemsToSyncWithIndexing (

	itemId  				bigint IDENTITY (1,1)	NOT NULL,

	aFileID					bigint	NOT NULL,

	aFileOffset				bigint	NOT NULL,

	CommCellNumber   		int	NOT NULL,

	OriginalFullPath 		nvarchar(4000) null,

	IndexGUID				varchar(128) null,

	IndexSyncTime			datetime null default GetDate(),

	SyncStatus				int null,

	idxAFileId				bigint null,

	idxAFileOffset			bigint null,

	idxCommCellNumber		int null,

	documentId				varchar(256) null,

	ResultSetID				char(36) null





CONSTRAINT [PK_DMItemsToSyncWithIndexing] PRIMARY KEY CLUSTERED(

[itemId] ASC

)WITH (IGNORE_DUP_KEY = OFF) ON [PRIMARY]

 

 )  ON [PRIMARY]





--CREATE NONCLUSTERED INDEX IDX_DMISyncWIndxng_ArchFileId ON DMItemsToSyncWithIndexing(aFileID)

--CREATE NONCLUSTERED INDEX IDX_DMISyncWIndxng_Path ON DMItemsToSyncWithIndexing(OriginalFullPath)

CREATE NONCLUSTERED INDEX IDX_DMISyncWIndxng_IndexGUID ON DMItemsToSyncWithIndexing(IndexGUID)



CREATE NONCLUSTERED INDEX IDX_DMItemsToSyncWithIndexing_aac ON DMItemsToSyncWithIndexing(aFileID, aFileOffset, CommCellNumber) INCLUDE (idxAFileId, idxAFileOffset, idxCommCellNumber, SyncStatus)



IF NOT EXISTS (SELECT * FROM systypes WHERE name = ''DMItemsToSyncWithIndexingTypeV2'')



CREATE TYPE DMItemsToSyncWithIndexingTypeV2 AS TABLE

(

aFileID					bigint,

aFileOffset				bigint,

CommCellNumber   		int,

OriginalFullPath 		nvarchar(4000),

IndexGUID				varchar(128),

SyncStatus				int,

idxAFileId				bigint,

idxAFileOffset			bigint,

idxCommCellNumber		int null,

ResultSetID				char(36) null

)

insert into GXDBVersions values(1, ''DMItemsToSyncWithIndexing'',  ''1.2'', ''DMItemsToSyncWithIndexing'', '''')

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 10 Table [GXDBVersions]''

END

-------------------------------------------------------------




')
END
IF (@retCode < 10)													
  	BEGIN																
  		IF NOT EXISTS (SELECT * FROM GXDBVersions WHERE name = 'DMItemsToSyncWithIndexing')			
  			insert into GXDBVersions VALUES(1, 'DMItemsToSyncWithIndexing', '0.0', 'DMItemsToSyncWithIndexing', '')	
  			UPDATE GXDBVersions SET revision = '1.2' WHERE name = 'DMItemsToSyncWithIndexing'		
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), @retCode) + 'Table [' + 'DMItemsToSyncWithIndexing' + '] upgraded successfully to '			+ ' revision [' + '1.2' + '].'										
  	END																	
  	else																
  		PRINT 'RETVAL: ' + CONVERT(CHAR(5), @retCode) + ' TABLE ' + 'DMItemsToSyncWithIndexing' + ' Upgrade Completed with Errors.'  
  	RETURN			   -- No more upgrade for this TABLE!-- Update cvTable & return

END

GO
IF @@error <> 0 RETURN
GO
