

--  ------------  Generated from [../../../Source/CommServer/DM2Db/Upgrade/DMUserSession.upg] ---------- 

--USE commserv
SET QUOTED_IDENTIFIER OFF
--$Id: DMUserSession.upg,v 1.7.2.1 2017/02/10 19:17:18 chandru Exp $
BEGIN--Need a Batch to return out of for concatenated scripts
DECLARE @oldRev CHAR(20)    		
  	DECLARE @oldVal CHAR(256)			
  	DECLARE @retCode   INTEGER			
  	DECLARE @sqlError  INTEGER			
  	SET     @retCode = 0              	
  	DECLARE @sqlString nvarchar(MAX)	
      DECLARE @parentID INTEGER				
      DECLARE @tName nvarchar(128)			
      DECLARE @colID INTEGER					
      DECLARE @constId INTEGER				
      DECLARE @cName   nvarchar(128)			
  	DECLARE @oldConstraintName   nvarchar(128)	
  	DECLARE @newConstraintName   nvarchar(128)	
  	DECLARE @keyname   nvarchar(128)		
      DECLARE @dbName   nvarchar(128)			
  	DECLARE @IsNullableAttr VARCHAR(100)	
  	DECLARE @DefaultValAttr NVARCHAR(MAX)	
  	DECLARE @DataType     NVARCHAR(	256)	
  	SET ROWCOUNT 0							
  	SET NOCOUNT ON--Declare/Initialize @oldRev, @oldVal, @retCode
SELECT @dbName = DB_NAME()													
  SELECT @oldRev = (SELECT revision FROM GXDBVersions WHERE name = 'DMUserSession')	
  IF (@oldRev IS NULL)														
  BEGIN                 														
      SET @oldRev = '0.0'														
  END																			
  IF NOT EXISTS (SELECT * FROM sysobjects										
  WHERE type = 'U'															
  AND name = 'DMUserSession')														
  BEGIN																		
  	SET @oldRev = '0.0'														
  	DELETE FROM GXDBVersions WHERE name = 'DMUserSession'							
  END																			
  IF (@oldRev = '1.6')       												
  BEGIN																		
      PRINT 'RETVAL: 0   Table [' +'DMUserSession' +'] does NOT require upgrade.'	
  END																			
  else																		
  BEGIN																		
      PRINT 'Upgrading Table [' +'DMUserSession' +'].'							
  END--	 Get @oldRev, compare to '1.6'. Chk for work to do.

--+-----------------------------------+
--| Know we have to do an update,		|
--| ea. one has it's own rules!		|
--+-----------------------------------+
	IF NOT EXISTS (select * from sysobjects where id = object_id(N'[dbo].[DMUserSession]') and OBJECTPROPERTY(id, N'IsTable') = 1)

	BEGIN


IF EXISTS (select * from sysobjects where id = object_id(N'[dbo].[DMUserSession]') and OBJECTPROPERTY(id, N'IsTable') = 1)
BEGIN
	EXECUTE cvsp_drop_pk 'DMUserSession'
	DROP TABLE DMUserSession
END
IF EXISTS (SELECT * FROM GXDBVersions WHERE name = 'DMUserSession')
BEGIN
	DELETE FROM GXDBVersions where name = 'DMUserSession' and type = 1
END
    



--  ------------  Generated from [../../../Source/CommServer/DM2Db/Tbl/DMUserSession.tbl] ---------- 





-- ALLOW_COMMENTS_BELOW_HERE:

-- ----------------------------------------------------------------------

--

--           Copyright (c) 1998  CommVault Systems, Inc.

--                  All rights reserved.

--

--

--        This is unpublished proprietary source code of CommVault

--        Systems, Inc. The copyright notice above does not evidence

--        any actual or intended publication of such source code.

-- ----------------------------------------------------------------------*/

-- rcsid="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/DM2Db/Tbl/DMUserSession.tbl,v $ $Id: DMUserSession.tbl,v 1.6 2015/07/13 15:56:55 chandru Exp $";

print '... Creating Table: DMUserSession'

exec ('



DECLARE @tblRetCode integer

Set NOCOUNT ON





create table DMUserSession (

	IP 				varchar(255)	NOT NULL,

	SessionID 			char(36)	NOT NULL,

	UserGUID 			char(36)	NOT NULL,

	CommCellNumber 	int	NOT NULL,

	UserName 			nvarchar(256)	NOT NULL,

	CreateTime 			datetime,

	Attribute 			int	NOT NULL,

	LastAccessTime		        datetime null,

	TimeOutInMin		int null,

	ConsoleType			int null,





CONSTRAINT PK_DMUserSession PRIMARY KEY NONCLUSTERED(SessionID)

 

 )  ON [PRIMARY]



set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

		set @tblRetCode = @@error;

		print ''RETVAL: 10 Table [DMUserSession]''

END

--------





create index IDX_DMUserSession_1 ON DMUserSession(UserGUID)

 

insert into GXDBVersions values(1, ''DMUserSession'',  ''1.6'', ''DMUserSession'', '''')

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 10 Table [GXDBVersions]''

END

-------------------------------------------------------------




')

	END

	ELSE

	BEGIN		

		IF EXISTS(

			SELECT * FROM INFORMATION_SCHEMA.COLUMNS 

			WHERE TABLE_NAME = 'DMUserSession' AND COLUMN_NAME = 'SessionId' AND CHARACTER_MAXIMUM_LENGTH <> 36

		)

		BEGIN

			ALTER TABLE DMUserSession

			ALTER COLUMN SessionId CHAR(36)

		END

		IF NOT EXISTS(

			SELECT * FROM INFORMATION_SCHEMA.COLUMNS 

			WHERE TABLE_NAME = 'DMUserSession' AND COLUMN_NAME = 'LastAccessTime'

		)

		BEGIN

			ALTER TABLE DMUserSession ADD LastAccessTime datetime

		END

		IF NOT EXISTS(

			SELECT * FROM INFORMATION_SCHEMA.COLUMNS 

			WHERE TABLE_NAME = 'DMUserSession' AND COLUMN_NAME = 'TimeOutInMin'

		)

		BEGIN

			ALTER TABLE DMUserSession ADD TimeOutInMin int

		END

		IF NOT EXISTS(

			SELECT * FROM INFORMATION_SCHEMA.COLUMNS 

			WHERE TABLE_NAME = 'DMUserSession' AND COLUMN_NAME = 'ConsoleType'

		)

		BEGIN

			ALTER TABLE DMUserSession ADD ConsoleType int

		END

		IF EXISTS (SELECT * FROM sysindexes WHERE name = 'IDX_DMUserSession_1') 

			DROP INDEX DMUserSession.IDX_DMUserSession_1

		create index IDX_DMUserSession_1 ON DMUserSession(UserGUID)

--Ideally, this should never happen (but just in case if we find null values, delete them)
		DELETE FROM DMUserSession WHERE SessionID IS NULL

--Make NOT NULL Before we proceed to add primary key constraint if needed.
		IF EXISTS

		(

			SELECT TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME, IS_NULLABLE

			FROM INFORMATION_SCHEMA.COLUMNS

			WHERE TABLE_NAME = 'DMUserSession' AND COLUMN_NAME = 'SessionId' AND IS_NULLABLE = 'YES'

		)

		BEGIN

			ALTER TABLE DMUserSession ALTER COLUMN SessionId char(36) NOT NULL

		END

		IF NOT EXISTS (SELECT * FROM sys.key_constraints WHERE type = 'PK'  AND name = 'PK_DMUserSession')

		BEGIN

--start clean up duplicates in DMUserSession (if any)
DECLARE @batchCnt INT = 10000--lets set to 10000
			IF OBJECT_ID('tempdb.dbo.#DupUserSession') IS NOT NULL

				DROP TABLE #DupUserSession			

--Create temp tbl for holding SessionId, which has duplicates
			CREATE TABLE #DupUserSession

			(

				SessionId VARCHAR(36),

			) ;	

			INSERT INTO #DupUserSession (sessionid)

			SELECT  TOP (@batchCnt) sessionid FROM DMUserSession 

			GROUP BY SessionID HAVING COUNT(*) > 1 

			WHILE EXISTS ( SELECT SessionId FROM #DupUserSession)

			BEGIN

				DELETE DM2Sess FROM

					(SELECT ROW_NUMBER() OVER (PARTITION BY sessionid ORDER BY sessionid) cnt

					FROM DMUserSession u where u.SessionID in (select SessionID FROM #DupUserSession)

					)DM2Sess

				WHERE DM2Sess.Cnt > 1

--delete data from temp table and populate next batch
				DELETE #DupUserSession			

				INSERT INTO #DupUserSession

				SELECT  TOP (@batchCnt) sessionid FROM DMUserSession 

				GROUP BY SessionID HAVING COUNT(*) > 1 

			END

			IF OBJECT_ID('tempdb.dbo.#DupUserSession') IS NOT NULL

				DROP TABLE #DupUserSession

--done clean up duplicates in DMUserSession. alter and add primary key constraint..
			EXEC('ALTER TABLE DMUserSession

			ADD CONSTRAINT PK_DMUserSession PRIMARY KEY NONCLUSTERED(SessionID)')

		END

	END

IF EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'DMUserSession' AND COLUMN_NAME="IP" AND 
  		(CASE WHEN CHARACTER_MAXIMUM_LENGTH = -1 THEN "MAX" ELSE CAST(CHARACTER_MAXIMUM_LENGTH AS VARCHAR(20)) END) !="255")			
  	BEGIN																														
  		SELECT	@DataType = DATA_TYPE,																							
  				@IsNullableAttr = (CASE WHEN IS_NULLABLE = 'NO' THEN ' NOT NULL ' ELSE ' NULL ' END),							
  				@DefaultValAttr = (CASE WHEN COLUMN_DEFAULT IS NULL THEN '' ELSE COLUMN_DEFAULT END)							
  		FROM INFORMATION_SCHEMA.COLUMNS																							
  		WHERE TABLE_NAME = 'DMUserSession' AND COLUMN_NAME="IP"							
  		IF (LEN(@DefaultValAttr) > 0)																		
  		BEGIN																								
  			SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'DMUserSession' AND xType = 'U')								
  			SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME="IP")			
  			SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  						WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  			IF (@constId IS NOT NULL)																			
  			BEGIN																								
  				  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  				  SET  @sqlString = 'ALTER TABLE [' + 'DMUserSession' +']' +'DROP CONSTRAINT [' + @cName + ']'		
  				  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  			END																									
  		END																										
  		SET @sqlString = "ALTER TABLE " + 'DMUserSession' + " ALTER COLUMN "+"IP" + " " + @DataType + "("+"255" + ") "			
  		+ " " + @IsNullableAttr 																				
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																							
  		IF (LEN(@DefaultValAttr) > 0)																			
  		BEGIN																									
  			SET @sqlString = "ALTER TABLE " + 'DMUserSession' + " ADD CONSTRAINT " + @cName  + " DEFAULT " + @DefaultValAttr + " FOR "+"IP"		
  			IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																						
  		END																										
  	END

IF (@retCode < 10)													
  	BEGIN																
  		IF NOT EXISTS (SELECT * FROM GXDBVersions WHERE name = 'DMUserSession')			
  			insert into GXDBVersions VALUES(1, 'DMUserSession', '0.0', 'DMUserSession', '')	
  			UPDATE GXDBVersions SET revision = '1.6' WHERE name = 'DMUserSession'		
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), @retCode) + 'Table [' + 'DMUserSession' + '] upgraded successfully to '			+ ' revision [' + '1.6' + '].'										
  	END																	
  	else																
  		PRINT 'RETVAL: ' + CONVERT(CHAR(5), @retCode) + ' TABLE ' + 'DMUserSession' + ' Upgrade Completed with Errors.'  
  	RETURN			   -- No more upgrade for this TABLE!-- Update cvTable & return

END

GO
IF @@error <> 0 RETURN
GO
